{"openapi":"3.0.0","servers":[{"description":"SwaggerHub API Auto Mocking","url":"https://virtserver.swaggerhub.com/Coder-for-Life/3DAdapt/1.0.0"},{"description":"Server","url":"https://3dadapt.xyz/api/v1"}],"info":{"title":"3DAdapt API","description":"3DAdapt API","version":"1.0.0","contact":{"email":"bushj@moravian.edu"},"license":{"name":"Apache 2.0","url":"http://www.apache.org/licenses/LICENSE-2.0.html"}},"tags":[{"name":"users","description":"User accounts and authentication"},{"name":"organization","description":"Organization of designs"},{"name":"designs","description":"Design information"},{"name":"makes","description":"Make information"},{"name":"likes","description":"Likes of designs, collections, and makes"},{"name":"collections","description":"Collections of designs"},{"name":"moderation","description":"Moderation of content on the site"}],"paths":{"/login":{"post":{"tags":["auth"],"summary":"Login","description":"Once a user is logged in, all authentication-required APIs are available (although 403 Forbidden responses are still possible for resources not available for this user)","operationId":"login_user","requestBody":{"description":"Authentication information, must provide username or email along with the password","content":{"application/json":{"schema":{"oneOf":[{"type":"object","required":["username","password"],"properties":{"username":{"type":"string","example":"coder-for-life"},"password":{"type":"string","format":"password","example":"secret"}}},{"type":"object","required":["email","password"],"properties":{"email":{"type":"string","format":"email","example":"bushj@moravian.edu"},"password":{"type":"string","format":"password","example":"secret"}}}]}}}},"responses":{"200":{"$ref":"#/components/responses/LoginTokens"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"description":"Unauthorized (401) - bad login information","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/refresh":{"post":{"tags":["auth"],"summary":"Refresh the user's logged in state","description":"Whenever the JWT access token expires the refresh token can be used to generate a new access token. Only the refresh token should be submitted at this point.","security":[{"jwt":[]}],"responses":{"200":{"description":"The refreshed access token for maintaining logged in state","content":{"application/json":{"schema":{"type":"object","properties":{"access_token":{"type":"string","description":"the JWT access token for maintaining logged-in state"}}}}}},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/logout":{"delete":{"tags":["auth"],"summary":"Logout a user, invalidating a token","description":"Only the refresh token must be submitted at this point. The access token will expire automatically after a short time but can be submitted if desired.","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/user":{"get":{"tags":["users"],"summary":"Get the current logged in user","operationId":"get_current_user","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/User"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"post":{"tags":["users"],"summary":"Create a user. This also auto-logins the user so JWT tokens are provided as well. NOTE: This can take up to 16 seconds to complete!","operationId":"create_user","requestBody":{"description":"user to create","content":{"application/json":{"schema":{"type":"object","required":["username","password","email"],"properties":{"username":{"type":"string","example":"coder-for-life"},"email":{"type":"string","format":"email","example":"bushj@moravian.edu"},"password":{"type":"string","format":"password","example":"secret","description":"minimum 8 characters and a \"50%\" complexity, no maximum length"},"agree_to_terms":{"type":"boolean","example":true,"description":"must be true to create an account"}}}}}},"responses":{"201":{"description":"Created user information and access token","content":{"application/json":{"schema":{"type":"object","required":["user","login"],"properties":{"user":{"$ref":"#/components/schemas/User"},"login":{"$ref":"#/components/schemas/LoginTokens"}}}}}},"400":{"description":"Bad Request (400) - bad request or invalid username/password/email","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"409":{"description":"Conflicting Resource (409) - a user with that username/email already exists","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"patch":{"tags":["users"],"summary":"Update the current logged in user. All fields are optional.","operationId":"update_current_user","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"subscriptions":{"$ref":"#/components/schemas/SubscriptionOptions"},"watch_update_freq":{"$ref":"#/components/schemas/UpdateFrequency"}}}}}},"responses":{"200":{"$ref":"#/components/responses/User"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/user/set-email":{"patch":{"tags":["users"],"summary":"Update the current logged in user's email. NOTE: This can take up to 16 seconds to complete!","operationId":"set_email","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["email"],"properties":{"email":{"type":"string","format":"email","example":"bushj@moravian.edu"}}}}}},"responses":{"200":{"$ref":"#/components/responses/User"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/user/set-password":{"put":{"tags":["users"],"summary":"Update the current user's password","operationId":"set_password","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["current_password","new_password"],"properties":{"current_password":{"type":"string","format":"password","example":"old-secret"},"new_password":{"type":"string","format":"password","example":"new-secret"}}}}}},"responses":{"200":{"$ref":"#/components/responses/LoginTokens"},"400":{"description":"Bad Request (400) - bad request, bad current password, or weak new password","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/user/password-reset":{"post":{"tags":["users"],"summary":"Initiate the reset of a user's password with their email (not username)","description":"Cause an email to be sent to the user with a code (6 random letters and numbers) to confirm. After submitting this, the user should be shown a screen to type in the code along with a new password. It should inform them that they have 15 minutes before the code expires. If the email is not found, this return success as to prevent hunting for registered emails.","operationId":"init_reset_password","requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["email"],"properties":{"email":{"type":"string","format":"email","example":"bushj@moravian.edu"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"}}},"put":{"tags":["users"],"summary":"Complete the reset of a user's password","description":"Must provide the same email that was provided to generate the code.","operationId":"reset_password","requestBody":{"content":{"application/json":{"schema":{"required":["email","token","password"],"properties":{"email":{"description":"their email","type":"string","example":"bushj@moravian.edu"},"token":{"description":"the code sent to the user's email (6 characters long)","type":"string"},"password":{"example":"the new password","type":"string"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"description":"Bad Request (400) - bad request or invalid password","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"404":{"description":"Not Found (404) - email and code do not match or code is expired","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/user/verify-email/send":{"put":{"tags":["users"],"summary":"Send the current user a verification email if they haven't already verified their email. This is automatically triggered when the user's account is created or their email is updated, this API is only needed if they lose the email.","operationId":"send_verification_email","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/user/verify-email/{code}":{"parameters":[{"name":"code","in":"path","required":true,"schema":{"type":"string","format":"uuid"},"example":"fe3d15b1-4283-448f-8ffc-39accd86f9ca"}],"get":{"tags":["users"],"summary":"Verify an email address with a special code. This is accomplished through the email sent to the user and not exposed to the user directly.","operationId":"verify_email","responses":{"200":{"$ref":"#/components/responses/Success"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/user/unsubscribe/{option}":{"parameters":[{"name":"option","in":"path","required":true,"schema":{"$ref":"#/components/schemas/SubscriptionOption"}}],"delete":{"tags":["users"],"summary":"Unsubscribe from a specific option","operationId":"unsubscribe","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"}}}},"/user/unsubscribe-from-all":{"delete":{"tags":["users"],"summary":"Unsubscribe from all options, does not include watches","operationId":"unsubscribe_from_all","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"}}}},"/users":{"get":{"tags":["users"],"parameters":[{"name":"with-permission","in":"query","description":"filter to users with the given permission, if not provided no filtering is done","allowEmptyValue":true,"schema":{"$ref":"#/components/schemas/Permission"}},{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"}],"summary":"List all users","description":"Not available in the app, only available to a limited set of users","operationId":"list_users","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"description":"page of users","content":{"application/json":{"schema":{"type":"object","required":["page","values"],"properties":{"page":{"$ref":"#/components/schemas/PageWithTotal"},"values":{"type":"array","items":{"$ref":"#/components/schemas/User"}}}}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"}}}},"/users/{username}":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get a user's info","description":"Not available in the app, only available to a limited set of users; generally you want to use /profile/{username}","operationId":"get_user","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/User"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/users/{username}/permissions":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get a user's permissions","description":"Not available in the app, only available to a limited set of users","operationId":"get_user_permissions","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"description":"The permissions for the given user","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Permissions"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"post":{"tags":["users"],"summary":"Set a user's permissions","description":"Not available in the app, only available to a limited set of users","operationId":"set_user_permissions","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Permissions"}}}},"responses":{"200":{"$ref":"#/components/responses/User"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["users"],"summary":"Add a permission to a user","description":"Not available in the app, only available to a limited set of users","operationId":"add_user_permissions","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Permissions"}}}},"responses":{"200":{"$ref":"#/components/responses/User"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["users"],"summary":"Remove all permissions from a user","description":"Not available in the app, only available to a limited set of users","operationId":"remove_user_permissions","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/User"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/users/{username}/lock":{"parameters":[{"$ref":"#/components/parameters/Username"}],"post":{"tags":["users"],"summary":"Lock a user, preventing that account from being logged into","description":"Not available in the app, only available to a limited set of users","operationId":"lock_user","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"201":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/users/{username}/unlock":{"parameters":[{"$ref":"#/components/parameters/Username"}],"post":{"tags":["users"],"summary":"Unlock a user, allowing that account to be logged into","description":"Any permissions set on the user before being locked will be erased. Not available in the app, only available to a limited set of users","operationId":"unlock_user","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"201":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile":{"get":{"tags":["users"],"summary":"Get the current user's profile.","operationId":"get_current_profile","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Profile"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"patch":{"tags":["users"],"summary":"Update the current user's profile","description":"All keys are optional and only provided keys are updated","operationId":"update_current_profile","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"tagline":{"type":"string","example":"Professor of Computer Science, Moravian University","description":"Max length is 255 characters","maxLength":255},"bio":{"type":"string","example":"Can be a very long string describing the person, <b>their goals with this tool</b>, and whatever...","format":"html","description":"HTML formatted, max length of 16384 characters","maxLength":16384},"roles":{"$ref":"#/components/schemas/Roles"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/avatar":{"put":{"tags":["users"],"summary":"Set the current user's avatar image","description":"Upload an image to use as the user's avatar image. The image should already be scaled and cropped to 300x300. If it isn't the server will adjust it, but this will waste a lot of bandwidth and server time.\n\nThe binary data of the image is sent directly (not wrapped in JSON or base64 encoded). The server supports at least PNG, JPEG, GIF, BMP, and WEBP file.\n","operationId":"set_current_profile_avatar","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/RawImage"},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"delete":{"tags":["users"],"summary":"Reset the current user's avatar image to the default","operationId":"reset_current_profile_avatar","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Profile"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/cover":{"put":{"tags":["users"],"summary":"Set the current user's cover image","description":"Upload an image to use as the user's cover image. The image should already be scaled and cropped to ???x???. If it isn't the server will adjust it, but this will waste a lot of bandwidth and server time.\n\nThe binary data of the image is sent directly (not wrapped in JSON or base64 encoded). The server supports at least PNG, JPEG, GIF, BMP, and WEBP file.\n","operationId":"set_current_profile_cover","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/RawImage"},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"delete":{"tags":["users"],"summary":"Reset the current user's cover image to the default","operationId":"reset_current_profile_cover","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Profile"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/favorites":{"get":{"tags":["users"],"summary":"Get the favorites of the current user as actual items instead of references","operationId":"get_favorites","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/FavoriteList"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"put":{"tags":["users"],"summary":"Set the list of favorites","operationId":"set_favorites","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ItemRef"},"maxLength":6}}}},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"post":{"tags":["users"],"summary":"Add an item as a favorite","operationId":"add_favorite","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ItemRef"}}}},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["users"],"summary":"Remove an item as a favorite","operationId":"remove_favorite","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ItemRef"}}}},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/followers":{"get":{"tags":["users"],"summary":"Get the followers of the current user (paged)","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"operationId":"get_followers","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/following":{"get":{"tags":["users"],"summary":"Get the users the current user is following (paged)","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"operationId":"get_following","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/following/{username}":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get if the current user is following the given user (same as /profiles/{username}/follow)","operationId":"is_following_user","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Boolean"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profile/unfollow-all":{"post":{"tags":["users"],"summary":"Unfollow all users","operationId":"unfollow_all","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"201":{"$ref":"#/components/responses/Success"}}}},"/profiles":{"get":{"tags":["users"],"summary":"Get a list of user profiles (paged)","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"operationId":"get_profiles","responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"}}}},"/profiles/{username}":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get a user's profile","operationId":"get_user_profile","responses":{"200":{"$ref":"#/components/responses/Profile"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["users"],"summary":"Update the a user's profile","description":"Not available in the app, only available to a limited set of users","operationId":"update_profile","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"tagline":{"type":"string","example":"Professor of Computer Science, Moravian University"},"bio":{"type":"string","example":"Can be a very long string describing the person, <b>their goals with this app</b>, and whatever...","format":"html","maxLength":16384,"description":"HTML formatted, max length of 16384 characters"},"roles":{"$ref":"#/components/schemas/Roles"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profiles/{username}/avatar":{"parameters":[{"$ref":"#/components/parameters/Username"}],"delete":{"tags":["users"],"summary":"Reset a user's avatar image to the default","description":"Not available in the app, only available to a limited set of users","operationId":"reset_profile_avatar","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profiles/{username}/cover":{"parameters":[{"$ref":"#/components/parameters/Username"}],"delete":{"tags":["users"],"summary":"Reset a user's cover image to the default","description":"Not available in the app, only available to a limited set of users","operationId":"reset_profile_cover","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Profile"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profiles/{username}/favorites":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get the favorites of a user as actual items instead of references","operationId":"get_user_favorites","responses":{"200":{"$ref":"#/components/responses/FavoriteList"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profiles/{username}/followers":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get the followers of the given user (paged)","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"operationId":"get_followers_of","responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"}}}},"/profiles/{username}/following":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get the users following the given user (paged)","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"operationId":"get_following_by","responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"}}}},"/profiles/{username}/follow":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["users"],"summary":"Get if the current user is following the given user (same as /profile/following/{username})","operationId":"is_following_user*","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Boolean"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"post":{"tags":["users"],"summary":"Have the current user follow another user","operationId":"follow_user","security":[{"jwt":[]}],"responses":{"200":{"description":"was already following the user","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"started following the user","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["users"],"summary":"Have the current user unfollow another user","operationId":"unfollow_user","security":[{"jwt":[]}],"responses":{"200":{"description":"was already not following the user","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"stopped following the user","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{follower}/follows/{followed}":{"parameters":[{"in":"path","name":"follower","required":true,"schema":{"type":"string"},"example":"coder-for-life"},{"in":"path","name":"followed","required":true,"schema":{"type":"string"},"example":"coder-for-life"}],"get":{"tags":["users"],"summary":"Check if a user follows another user","operationId":"follows","responses":{"200":{"$ref":"#/components/responses/Boolean"}}}},"/reports":{"get":{"tags":["moderation"],"summary":"Get reports submitted by the current user","operationId":"list_my_reports","security":[{"jwt":[]}],"parameters":[{"name":"unresolved","in":"query","description":"Only return unresolved reports","allowEmptyValue":true,"schema":{"type":"boolean","default":false}},{"name":"search","in":"query","description":"Only return reports that match this search query","allowEmptyValue":true,"schema":{"type":"string","default":null}},{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"}],"responses":{"200":{"description":"page of reports","content":{"application/json":{"schema":{"type":"object","properties":{"page":{"$ref":"#/components/schemas/PageWithTotal"},"reports":{"type":"array","items":{"$ref":"#/components/schemas/ReportBrief"}}}}}}},"401":{"$ref":"#/components/responses/Unauthorized"}}},"post":{"tags":["moderation"],"summary":"Submit a report/flag about inappropriate content on the site","operationId":"submit_report","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["type","item","details"],"properties":{"type":{"$ref":"#/components/schemas/ReportItemType"},"item":{"description":"The identifier of the thing being reported, for a profile this is the username for others this is their ID","type":"string","example":"coder-for-life"},"comment_id":{"description":"The id of the comment if the reported item is a comment, not populated otherwise","type":"integer"},"details":{"description":"The detailed information about what is inappropriate about the content","type":"string","minLength":16,"maxLength":8192}}}}}},"responses":{"201":{"$ref":"#/components/responses/Report"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/reports/{id}":{"parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"get":{"tags":["moderation"],"summary":"Get a report from its id","operationId":"get_report","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Report"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"post":{"tags":["moderation"],"summary":"Comment on a report and possibly mark it as resolved","operationId":"comment_on_report","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"The comment text","type":"string","minLength":16,"maxLength":8192},"resolve":{"description":"If this comment marks the report as resolved. If this is included, this always sets the resolved state (so can set it to false i.e. un-resolve it). To keep the current state, don't provide this key or set it to null.","type":"boolean","default":false}}}}}},"responses":{"201":{"$ref":"#/components/responses/Report"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/reports/moderation":{"get":{"tags":["moderation"],"summary":"Get reports submitted for moderation","operationId":"list_reports","deprecated":true,"security":[{"jwt":[]}],"parameters":[{"name":"unresolved","in":"query","description":"Only return unresolved reports","allowEmptyValue":true,"schema":{"type":"boolean","default":false}},{"name":"search","in":"query","description":"Only return reports that match this search query","allowEmptyValue":true,"schema":{"type":"string","default":null}},{"name":"type","in":"query","description":"Only return reports that match this type","allowEmptyValue":true,"schema":{"$ref":"#/components/schemas/ReportItemType"}},{"name":"updatedBefore","in":"query","description":"Only return reports that were last updated before the given date (no time)","allowEmptyValue":true,"schema":{"type":"string","format":"datetime"}},{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"}],"responses":{"200":{"description":"page of reports","content":{"application/json":{"schema":{"type":"object","properties":{"page":{"$ref":"#/components/schemas/PageWithTotal"},"reports":{"type":"array","items":{"$ref":"#/components/schemas/ReportBrief"}}}}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"}}}},"/licenses":{"get":{"tags":["other"],"summary":"Get the list of all usable licenses","description":"These should be cached and only refreshed once in a long while (like weekly or monthly maybe). All of the images should be cached as well.","operationId":"get_licenses","responses":{"200":{"description":"list of all licenses","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/License"}}}}}}},"post":{"tags":["other"],"summary":"Add a new license","description":"This should not be made available through the app, this will only be available to a select few individuals.","operationId":"add_license","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/License"}}}},"responses":{"201":{"$ref":"#/components/responses/License"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/licenses/{name}":{"parameters":[{"name":"name","in":"path","required":true,"schema":{"type":"string"},"example":"CC BY-NC-ND"}],"get":{"tags":["other"],"summary":"Get a single license by name","operationId":"get_license","responses":{"200":{"$ref":"#/components/responses/License"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["other"],"summary":"Update a license","description":"This should not be made available through the app, this will only be available to a select few individuals.","operationId":"update_license","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"description":"name cannot be changed, all other fields are optional in this context","content":{"application/json":{"schema":{"$ref":"#/components/schemas/License"}}}},"responses":{"200":{"$ref":"#/components/responses/License"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/tags":{"get":{"tags":["organization"],"summary":"Get the list of all tags. Should be cached. In all other APIs, only the id of the tag is used.","operationId":"get_tags","responses":{"200":{"description":"The list of tags","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Tag"}}}}}}},"post":{"tags":["organization"],"summary":"Add a new tag; Not available in app","operationId":"add_tag","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Tag"}}}},"responses":{"201":{"$ref":"#/components/responses/Tag"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/tags/{id}":{"parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"patch":{"tags":["organization"],"summary":"Update a tag. Not available in the app.","description":"All fields are optional, if not provided will not be changed.","operationId":"update_tag","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"code":{"type":"string","example":"d329"},"category":{"type":"string","example":"env"},"short":{"type":"string","example":"Receiving"},"name":{"type":"string","example":"Communication - Receiving"},"desc":{"type":"string"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Tag"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"}}},"delete":{"tags":["organization"],"summary":"Remove a tag. Only possible with empty tags. Not available in the app.","operationId":"delete_tag","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/categories":{"get":{"tags":["organization"],"summary":"Get the list of all categories. Should be cached. In all other APIs, only the id of the category is used.","operationId":"get_categories","responses":{"200":{"description":"The list of categories","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Category"}}}}}}},"post":{"tags":["organization"],"summary":"Add a new category; Not available in app","operationId":"add_category","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Category"}}}},"responses":{"201":{"$ref":"#/components/responses/Category"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/categories/{id}":{"parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"patch":{"tags":["organization"],"summary":"Update a category. Not available in the app.","description":"All fields are optional, if not provided will not be changed.","operationId":"update_category","deprecated":true,"security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string","example":"activity"},"order":{"type":"integer","example":3}}}}}},"responses":{"200":{"$ref":"#/components/responses/Category"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"}}},"delete":{"tags":["organization"],"summary":"Remove a category. Only possible with empty categories. Not available in the app.","operationId":"delete_category","deprecated":true,"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/design":{"post":{"tags":["designs"],"summary":"Add a new design","description":"This creates the basics of a new design but after this the images and files must be uploaded as well","operationId":"add_design","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["name","purpose","tags","license","desc"],"properties":{"name":{"description":"name for this design","type":"string","example":"Assistive Bottle Opener","minLength":8,"maxLength":255},"purpose":{"description":"short string describing the purpose of this design","type":"string","example":"Helps you open a bottle","minLength":32,"maxLength":255},"tags":{"description":"the list of tags assigned to this design","type":"array","items":{"type":"string"},"minLength":3,"maxLength":16},"remix_of":{"description":"optional; the design id of what this design was remixed from","type":"string"},"customizable":{"description":"if the design can be customized","type":"boolean","default":false},"license":{"description":"a license id","type":"string","example":"CC-BY-NC-ND"},"desc":{"description":"description of the design","type":"string","format":"html","maxLength":32768},"external":{"$ref":"#/components/schemas/External"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Design"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/design/grab":{"get":{"tags":["designs"],"summary":"Grab a design from an external source","operationId":"grab_external_design","parameters":[{"in":"query","name":"url","description":"the URL to grab data from","schema":{"type":"string"}}],"responses":{"200":{"description":"grabbed information, roughly lining up with a design value","content":{"application/json":{"schema":{"type":"object","required":["name","external","license","images","files","desc"],"properties":{"name":{"type":"string","example":"Assistive Bottle Opener","maxLength":255},"external":{"$ref":"#/components/schemas/External"},"cover":{"description":"external URL to the cover photo for this item","type":"string","format":"url","example":"https://3dadapt.xyz/images/abcdef.webp"},"license":{"description":"a license id","type":"string","example":"CC-BY-NC-ND"},"desc":{"description":"description of the item, not included except when a single item is directly requested","type":"string","format":"html","maxLength":32768},"remix_of":{"description":"the external URL remixed from, or null","type":"string","format":"url","default":null},"images":{"description":"List of image names/descriptions and external URLs","type":"array","items":{"type":"array","minLength":2,"maxLength":2,"items":{"type":"string"}}},"files":{"description":"Object associating file name/description with external URL","type":"object","additionalProperties":{"description":"the URL for each file","type":"string","format":"url"}}}}}}},"400":{"$ref":"#/components/responses/BadRequest"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/design/import":{"post":{"tags":["designs"],"summary":"Import a design from an external source","operationId":"import_design","security":[{"jwt":[]}],"requestBody":{"description":"the design to import and additional needed information","content":{"application/json":{"schema":{"type":"object","required":["url","purpose","tags"],"properties":{"url":{"type":"string","example":"external URL of the design to import"},"purpose":{"description":"short string describing the purpose of this design","type":"string","example":"Helps you open a bottle","maxLength":255},"tags":{"description":"the list of tags assigned to this design","type":"array","items":{"type":"string"},"default":[]}}}}}},"responses":{"200":{"$ref":"#/components/responses/Design"},"400":{"$ref":"#/components/responses/BadRequest"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"}}}},"/design/import-many":{"post":{"tags":["designs"],"summary":"Import many designs from an external source, must be a moderator to use this. Automatically skips already-imported designs.","operationId":"import_designs","security":[{"jwt":[]}],"requestBody":{"description":"the designs to import and their additional needed information","content":{"application/json":{"schema":{"type":"array","items":{"type":"object","required":["url","purpose","tags"],"properties":{"url":{"type":"string","example":"external URL of the design to import"},"purpose":{"description":"short string describing the purpose of this design","type":"string","example":"Helps you open a bottle","maxLength":255},"tags":{"description":"the list of tags assigned to this design","type":"array","items":{"type":"string"},"default":[]}}}}}}},"responses":{"200":{"description":"streaming status messages, since this command can take quite a long time, this streams the results of each individual import","content":{"text/plain":{"schema":{"type":"string"}}}},"400":{"$ref":"#/components/responses/BadRequest"}}}},"/designs":{"get":{"tags":["designs"],"summary":"Get the list of designs","operationId":"get_designs","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"description":"page of designs","content":{"application/json":{"schema":{"type":"object","required":["page","values","tags"],"properties":{"page":{"$ref":"#/components/schemas/Page"},"values":{"type":"array","items":{"$ref":"#/components/schemas/Design"}},"tags":{"description":"Object of all of tags (keys) and their counts (values) for the entire given search (not just the single page), not including 0 count tags","type":"object","additionalProperties":{"description":"the count of each tag","type":"integer"},"example":{"d329":2,"d349":1,"e110":1}}}}}}}}}},"/designs/{design}":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["designs"],"summary":"Get a full design by id; the images and files fields are returned fully in this case instead of counts","operationId":"get_design","responses":{"200":{"$ref":"#/components/responses/Design"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["designs"],"summary":"Update an design","description":"Only the given keys will be updated","operationId":"update_design","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"description":"name for this design","type":"string","example":"Assistive Bottle Opener","minLength":8,"maxLength":255},"purpose":{"description":"short string describing the purpose of this design","type":"string","example":"Helps you open a bottle","minLength":32,"maxLength":255},"tags":{"description":"the list of tags assigned to this design","type":"array","items":{"type":"string"},"minLength":3,"maxLength":16},"remix_of":{"description":"optional; the design id of what this design was remixed from","type":"string"},"customizable":{"description":"if the design can be customized","type":"boolean","default":false},"license":{"description":"a license id","type":"string","example":"CC-BY-NC-ND"},"desc":{"description":"description of the design","type":"string","format":"html","maxLength":32768},"cover":{"description":"image link to set as the cover image for this design","type":"string"},"external":{"$ref":"#/components/schemas/External"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Design"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["designs"],"summary":"Delete an unpublished design","description":"You can only delete designs that have not been published","operationId":"remove_design","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/file":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"post":{"tags":["designs"],"summary":"Add a files to a design","operationId":"add_design_file","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/AddFile"},"responses":{"201":{"$ref":"#/components/responses/File"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/files/{id}":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/FileId"}],"patch":{"tags":["designs"],"summary":"Update a file in a design","operationId":"update_design_file","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/UpdateFile"},"responses":{"201":{"$ref":"#/components/responses/File"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["designs"],"summary":"Delete an image from a design","operationId":"remove_design_file","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/files/{id}/customize":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/FileId"}],"post":{"tags":["designs"],"summary":"Customize a file in a design, needs to be polled until complete","operationId":"customize_file","security":[{"jwt":[]}],"requestBody":{"description":"customization parameters","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomizationValues"}}}},"responses":{"200":{"$ref":"#/components/responses/CustomizedFile"},"201":{"$ref":"#/components/responses/CustomizedFile"},"400":{"$ref":"#/components/responses/BadRequest"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/printset":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"post":{"tags":["designs"],"summary":"Add a printset to a design","operationId":"add_design_printset","security":[{"jwt":[]}],"requestBody":{"description":"printset information, all fields are optional","content":{"application/json":{"schema":{"type":"object","required":["name","files"],"properties":{"name":{"description":"name of the printset","type":"string","maxLength":255},"desc":{"description":"optional description of the printset","type":"string","maxLength":255,"default":""},"files":{"description":"list of file information for this printset","minLength":1,"maxLength":25,"type":"array","items":{"oneOf":[{"type":"string","description":"file id"},{"$ref":"#/components/schemas/PrintsetFile"}]}}}}}}},"responses":{"201":{"$ref":"#/components/responses/Printset"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/printsets/{id}":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/PrintsetId"}],"patch":{"tags":["designs"],"summary":"Update a printset in a design","operationId":"update_design_printset","security":[{"jwt":[]}],"requestBody":{"description":"printset information to be updated, all fields are optional","content":{"application/json":{"schema":{"type":"object","properties":{"name":{"description":"name of the printset","type":"string","maxLength":255,"default":null},"desc":{"description":"optional description of the printset","type":"string","maxLength":255,"default":null},"files":{"description":"list of file information for this printset; completely replaces any existing list of files","minLength":1,"maxLength":25,"default":null,"type":"array","items":{"oneOf":[{"type":"string","description":"file id"},{"$ref":"#/components/schemas/PrintsetFile"}]}}}}}}},"responses":{"201":{"$ref":"#/components/responses/Printset"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["designs"],"summary":"Delete an image from a design","operationId":"remove_design_printset","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/printset/{id}/customize":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/PrintsetId"}],"post":{"tags":["designs"],"summary":"Customize a printset in a design","operationId":"customize_printset","security":[{"jwt":[]}],"requestBody":{"description":"customization parameters","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CustomizationValues"}}}},"responses":{"200":{"$ref":"#/components/responses/CustomizedPrintset"},"201":{"$ref":"#/components/responses/CustomizedPrintset"},"400":{"$ref":"#/components/responses/BadRequest"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/remixes":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["designs"],"summary":"Get the list of remixes of a design, needs to be polled until complete","operationId":"get_design_remixes","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/designs":{"get":{"tags":["designs"],"summary":"Get the list of designs by the current user, does not include imports","operationId":"get_designs_self","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/designs":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["designs"],"summary":"Get the list of designs by a specific user, does not include imports","operationId":"get_designs_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/imports":{"get":{"tags":["designs"],"summary":"Get the list of imported designs by the current user","operationId":"get_imports_self","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/imports":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["designs"],"summary":"Get the list of imported designs by a specific user","operationId":"get_imports_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/ordering-services":{"get":{"tags":["orders"],"summary":"Get the list of ordering services","operationId":"get_ordering_services","responses":{"200":{"description":"List of all known ordering services","content":{"application/json":{"schema":{"type":"object","additionalProperties":{"type":"object","required":["id","order","logo","banner","name","url","description"],"properties":{"order":{"description":"the order the services should be displayed in","type":"integer"},"id":{"description":"the id of the service","type":"string"},"name":{"description":"the display name of the service","type":"string"},"url":{"description":"the homepage url of the service","type":"string","format":"uri"},"logo":{"description":"URL of the logo image, 600x400px","type":"string","format":"uri"},"banner":{"description":"URL of the banner image, 2000x250px","type":"string","format":"uri"},"description":{"description":"the description of the service","type":"string"}}}}}}}}}},"/order":{"post":{"tags":["orders"],"summary":"Create a new order","description":"This creates a new order and returns the redirect URL to complete the order; this may require being called multiple times until it is ready","operationId":"order","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["type","design","id","service"],"properties":{"type":{"description":"type of item being ordered","type":"string","enum":["file","printset"]},"design":{"description":"design containing the item being ordered","type":"string","maxLength":64},"id":{"description":"id of the item being ordered","type":"string","maxLength":64},"params":{"$ref":"#/components/schemas/CustomizationValues"},"service":{"description":"ordering service to use","type":"string"},"options":{"description":"options for the ordering service","type":"object"}}}}}},"responses":{"200":{"description":"Order started (or pending)","content":{"application/json":{"schema":{"type":"object","properties":{"url":{"description":"redirection url to complete the order, if null, the request must be submitted again in a short amount of time (it is waiting for customization or similar to complete)","type":"string","format":"uri","default":null}}}}}},"400":{"$ref":"#/components/responses/BadRequest"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"},"500":{"description":"Internal Server Error (500)","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"503":{"description":"Service Unavailable (503)","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}},"/designs/{design}/make":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"post":{"tags":["makes"],"summary":"Add a new make","description":"This creates the basics of a new make but after this the images must be uploaded as well","operationId":"add_make","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["desc"],"properties":{"desc":{"description":"description of the make","type":"string","format":"html","maxLength":8192},"ratings":{"$ref":"#/components/schemas/MakeRatings"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Make"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes":{"get":{"tags":["makes"],"summary":"Get the list of makes","operationId":"get_makes","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakes"},"400":{"$ref":"#/components/responses/BadRequest"}}}},"/makes/{make}":{"parameters":[{"$ref":"#/components/parameters/MakeId"}],"get":{"tags":["makes"],"summary":"Get a full make by id; the images field is returned fully in this case instead of just the count","operationId":"get_make","responses":{"200":{"$ref":"#/components/responses/Make"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["makes"],"summary":"Update a make","description":"Only the given keys will be updated","operationId":"update_make","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"desc":{"description":"description of the make","type":"string","format":"html","maxLength":8192},"ratings":{"$ref":"#/components/schemas/MakeRatings"},"cover":{"description":"image link to set as the cover image for this make","type":"string"}}}}}},"responses":{"200":{"$ref":"#/components/schemas/Make"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["makes"],"summary":"Delete a make","operationId":"remove_make","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/makes":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["makes"],"summary":"Get the list of makes of a particular design","operationId":"get_makes_of","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakes"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/makes":{"get":{"tags":["makes"],"summary":"Get the list of makes by the current user","operationId":"get_makes_self","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakes"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/makes":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["makes"],"summary":"Get the list of makes by a specific user","operationId":"get_makes_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakes"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collection":{"post":{"tags":["collections"],"summary":"Create a collection","operationId":"create_collection","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["name"],"properties":{"name":{"type":"string","example":"Things to Make","maxLength":255},"desc":{"type":"string","maxLength":8192}}}}}},"responses":{"201":{"$ref":"#/components/responses/Collection"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/collections":{"get":{"tags":["collections"],"summary":"Get the collections of a user","operationId":"get_collections","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"}}}},"/collections/{collection}":{"parameters":[{"$ref":"#/components/parameters/CollectionId"}],"get":{"tags":["collections"],"summary":"Get a collection","operationId":"get_collection","responses":{"200":{"$ref":"#/components/responses/Collection"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["collections"],"summary":"Update a collection","description":"All keys are optional and only provided keys are updated","operationId":"update_collection","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string","example":"Things to Make","maxLength":255},"desc":{"type":"string","maxLength":8192},"cover_item":{"description":"The id of the design to use for the \"cover\" image; must be in the collection","type":"string","example":"my-first-design"},"owners":{"description":"The new set of owners for the collection","$ref":"#/components/schemas/Owners"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Collection"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["collections"],"summary":"Remove a collection","operationId":"remove_collection","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/owners":{"parameters":[{"$ref":"#/components/parameters/CollectionId"}],"get":{"tags":["collections"],"summary":"Get the owners of a collection","operationId":"get_collection_owners","responses":{"200":{"description":"profiles of owners","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Profile"}}}}},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"tags":["collections"],"summary":"Change the owners of a collection","operationId":"set_collection_owners","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"owners":{"description":"The new set of owners for the collection","$ref":"#/components/schemas/Owners"}}}}}},"responses":{"200":{"$ref":"#/components/responses/Owners"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["collections"],"summary":"Remove the current user as a collection's owner","description":"This will fail if this is the last owner of the collection.","operationId":"remove_collection_owner_self","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/owners/{username}":{"parameters":[{"$ref":"#/components/parameters/CollectionId"},{"$ref":"#/components/parameters/Username"}],"post":{"tags":["collections"],"summary":"Add an owner to a collection","description":"This will fail if there are too many owners of the collection","operationId":"add_collection_owner","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Owners"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["collections"],"summary":"Remove a collection's owner","description":"This will fail if this is the last owner of the collection.","operationId":"remove_collection_owner","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Owners"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/designs":{"parameters":[{"$ref":"#/components/parameters/CollectionId"}],"get":{"tags":["collections"],"summary":"Get the designs of a collection","operationId":"get_collection_designs","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/designs/{design}":{"parameters":[{"$ref":"#/components/parameters/CollectionId"},{"$ref":"#/components/parameters/DesignId"}],"post":{"tags":["users"],"summary":"Add a design to a collection","operationId":"add_design_to_collection","security":[{"jwt":[]}],"responses":{"200":{"description":"was already in collection","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"added to collection","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["users"],"summary":"Remove a design from a collection","operationId":"remove_design_from_collection","security":[{"jwt":[]}],"responses":{"200":{"description":"was already not in the collection","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"removed from the collection","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/collections":{"get":{"tags":["collections"],"summary":"Get the collections of the current user","operationId":"get_collections_self","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profiles/{username}/collections":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["collections"],"summary":"Get the collections of a user","operationId":"get_collections_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/collections":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["collections"],"summary":"Get the list of collections that have a particular design (as pages)","operationId":"get_design_collections","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/collections-by/me":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["collections"],"summary":"Get the list of collections that have a particular design and owned by the current user (as pages)","operationId":"get_design_collections_self","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/collections-by/<username>":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/Username"}],"get":{"tags":["collections"],"summary":"Get the list of collections that have a particular design and owned by a particular user (as pages)","operationId":"get_design_collections_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/image":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"post":{"tags":["designs"],"summary":"Upload an image into a design","operationId":"add_design_image","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/AddImage"},"responses":{"201":{"$ref":"#/components/responses/Design"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/images":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"put":{"tags":["designs"],"summary":"Reorder the images of a design","description":"Send a list of the image links in the order they should be displayed, any links not included will be placed at the end","security":[{"jwt":[]}],"operationId":"reorder_design_images","requestBody":{"description":"list of image links","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}}}}},"responses":{"200":{"$ref":"#/components/responses/Design"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"parameters":[{"$ref":"#/components/parameters/ImageLink"}],"tags":["designs"],"summary":"Update an image in a design","operationId":"update_design_image","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/UpdateImage"},"responses":{"201":{"$ref":"#/components/responses/Design"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"parameters":[{"$ref":"#/components/parameters/ImageLinks"}],"tags":["designs"],"summary":"Delete images from a design","operationId":"remove_design_images","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Design"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/image":{"parameters":[{"$ref":"#/components/parameters/MakeId"}],"post":{"tags":["makes"],"summary":"Upload an image into a make","operationId":"add_make_image","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/AddImage"},"responses":{"201":{"$ref":"#/components/responses/Make"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/images":{"parameters":[{"$ref":"#/components/parameters/MakeId"}],"put":{"tags":["makes"],"summary":"Reorder the images of a make","description":"Send a list of the image links in the order they should be displayed, any links not included will be placed at the end","security":[{"jwt":[]}],"operationId":"reorder_make_images","requestBody":{"description":"list of image links","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}}}}},"responses":{"200":{"$ref":"#/components/responses/Make"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"patch":{"parameters":[{"$ref":"#/components/parameters/ImageLink"}],"tags":["makes"],"summary":"Update an image in a make","operationId":"update_make_image","security":[{"jwt":[]}],"requestBody":{"$ref":"#/components/requestBodies/UpdateImage"},"responses":{"201":{"$ref":"#/components/responses/Make"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"parameters":[{"$ref":"#/components/parameters/ImageLinks"}],"tags":["makes"],"summary":"Delete images from a make","operationId":"remove_make_images","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Make"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/Forbidden"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/comment":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"post":{"tags":["designs"],"summary":"Add a new comment to a design","operationId":"add_design_comment","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"text for this comment","type":"string","format":"html","maxLength":8192},"reply_to":{"description":"id of comment being replied to","type":"integer"}}}}}},"responses":{"200":{"$ref":"#/components/responses/DesignComment"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/comments":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["designs"],"summary":"Get the comments of a design","description":"Comment pages involve nested paging since each comment can have replies","operationId":"get_design_comments","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/MaxDepth"},{"$ref":"#/components/parameters/ReplyLimit"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesignComments"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/comments/{comment}":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/CommentId"}],"patch":{"tags":["designs"],"summary":"Update a comment on a design","operationId":"update_design_comment","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"text for this comment","type":"string","format":"html","maxLength":8192}}}}}},"responses":{"200":{"$ref":"#/components/responses/DesignComment"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["designs"],"summary":"Remove a comment on a design","description":"If the comment has replies, it is not removed but instead the text and username are replaced with [deleted]","operationId":"remove_design_comment","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/comments/{comment}/reply":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/CommentId"}],"post":{"tags":["designs"],"summary":"Add a new reply to a comment on a design","operationId":"add_design_comment_reply","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"text for this comment","type":"string","format":"html","maxLength":8192}}}}}},"responses":{"200":{"$ref":"#/components/responses/DesignComment"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/comments/{comment}/replies":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/CommentId"}],"get":{"tags":["designs"],"summary":"Get the reply comments of a design","description":"This endpoint is for dealing with the nested paging of comments","operationId":"get_design_comments_replies","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/MaxDepth"},{"$ref":"#/components/parameters/ReplyLimit"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesignComments"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/comment":{"parameters":[{"$ref":"#/components/parameters/MakeId"}],"post":{"tags":["makes"],"summary":"Add a new comment to a make","operationId":"add_make_comment","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"text for this comment","type":"string","format":"html","maxLength":8192},"reply_to":{"description":"id of comment being replied to","type":"integer"}}}}}},"responses":{"200":{"$ref":"#/components/responses/MakeComment"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/comments":{"parameters":[{"$ref":"#/components/parameters/MakeId"}],"get":{"tags":["makes"],"summary":"Get the comments of a make","description":"Comment pages involve nested paging since each comment can have replies","operationId":"get_make_comments","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/MaxDepth"},{"$ref":"#/components/parameters/ReplyLimit"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakeComments"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/comments/{comment}":{"parameters":[{"$ref":"#/components/parameters/MakeId"},{"$ref":"#/components/parameters/CommentId"}],"patch":{"tags":["makes"],"summary":"Update a comment on a make","operationId":"update_make_comment","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"text for this comment","type":"string","format":"html","maxLength":8192}}}}}},"responses":{"200":{"$ref":"#/components/responses/MakeComment"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["makes"],"summary":"Remove a comment on a make","description":"If the comment has replies, it is not removed but instead the text and username are replaced with [deleted]","operationId":"remove_make_comment","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Success"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/comments/{comment}/reply":{"parameters":[{"$ref":"#/components/parameters/MakeId"},{"$ref":"#/components/parameters/CommentId"}],"post":{"tags":["makes"],"summary":"Add a new reply to a comment on a make","operationId":"add_make_comment_reply","security":[{"jwt":[]}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","required":["text"],"properties":{"text":{"description":"text for this comment","type":"string","format":"html","maxLength":8192}}}}}},"responses":{"200":{"$ref":"#/components/responses/MakeComment"},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/comments/{comment}/replies":{"parameters":[{"$ref":"#/components/parameters/MakeId"},{"$ref":"#/components/parameters/CommentId"}],"get":{"tags":["makes"],"summary":"Get the reply comments of a make","description":"This endpoint is for dealing with the nested paging of comments","operationId":"get_make_comments_replies","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/MaxDepth"},{"$ref":"#/components/parameters/ReplyLimit"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakeComments"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/likes":{"get":{"tags":["likes"],"summary":"Get the list of designs, makes, and collections liked by the current user (as pages)","description":"The sort only supports the most basic \"newest\" and \"likes\"; other filters only apply to items that support them","operationId":"get_liked","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfItems"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/likes":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["likes"],"summary":"Get the list of designs, makes, and collections liked by a user (as pages)","description":"The sort only supports the most basic \"newest\" and \"likes\"; other filters only apply to items that support them; search is not supported","operationId":"get_liked_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfItems"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/likes/designs":{"get":{"tags":["likes"],"summary":"Get the list of designs liked by the current user (as pages)","operationId":"get_liked_designs","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/likes/designs":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["likes"],"summary":"Get the list of designs liked by a user (as pages)","operationId":"get_liked_designs_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Tags"},{"$ref":"#/components/parameters/Customizable"},{"$ref":"#/components/parameters/HasSingle"},{"$ref":"#/components/parameters/HasMakes"},{"$ref":"#/components/parameters/IsRemix"},{"$ref":"#/components/parameters/Made"},{"$ref":"#/components/parameters/Collected"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfDesigns"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/like":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["likes"],"summary":"Get if the current user likes a design","operationId":"is_design_liked","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Boolean"},"401":{"$ref":"#/components/responses/Unauthorized"}}},"post":{"tags":["likes"],"summary":"Mark that the current user likes a design","operationId":"like_design","security":[{"jwt":[]}],"responses":{"200":{"description":"design was already liked","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"liked design","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["likes"],"summary":"Un-Mark that the current user likes a design","operationId":"unlike_design","security":[{"jwt":[]}],"responses":{"200":{"description":"design was already not liked","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"no longer liked design","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/designs/{design}/liked-by/{username}":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/Username"}],"get":{"tags":["likes"],"summary":"Get if the user likes a design","operationId":"is_design_liked_by","responses":{"200":{"$ref":"#/components/responses/Boolean"}}}},"/designs/{design}/likes":{"parameters":[{"$ref":"#/components/parameters/DesignId"}],"get":{"tags":["likes"],"summary":"Get the list of users who like a design (as pages)","operationId":"get_design_likes","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/likes/collections":{"get":{"tags":["likes"],"summary":"Get the list of collections liked by the current user (as pages)","operationId":"get_liked_collections","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/likes/collections":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["likes"],"summary":"Get the list of collections liked by a user (as pages)","operationId":"get_liked_collections_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfCollections"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/like":{"parameters":[{"$ref":"#/components/parameters/Username"},{"$ref":"#/components/parameters/CollectionId"}],"get":{"tags":["likes"],"summary":"Get if the current user likes a collection","operationId":"is_collection_liked","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Boolean"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"post":{"tags":["likes"],"summary":"Mark that the current user likes a collection","operationId":"like_collection","security":[{"jwt":[]}],"responses":{"200":{"description":"collection was already liked","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"liked collection","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["likes"],"summary":"Un-Mark that the current user likes a collection","operationId":"unlike_collection","security":[{"jwt":[]}],"responses":{"200":{"description":"collection was already not liked","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"no longer liked collection","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/liked-by/{username}":{"parameters":[{"$ref":"#/components/parameters/Username"},{"$ref":"#/components/parameters/CollectionId"}],"get":{"tags":["likes"],"summary":"Get if the user likes a collection","operationId":"is_collection_liked_by","responses":{"200":{"$ref":"#/components/responses/Boolean"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/collections/{collection}/likes":{"parameters":[{"$ref":"#/components/parameters/Username"},{"$ref":"#/components/parameters/CollectionId"}],"get":{"tags":["likes"],"summary":"Get the list of users who like a collection (as pages)","operationId":"get_collection_likes","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Roles"},{"$ref":"#/components/parameters/AllRoles"}],"responses":{"200":{"$ref":"#/components/responses/PageOfProfiles"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/profile/likes/makes":{"get":{"tags":["likes"],"summary":"Get the list of makes liked by the current user (as pages)","operationId":"get_liked_makes","security":[{"jwt":[]}],"parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakes"},"401":{"$ref":"#/components/responses/Unauthorized"}}}},"/profiles/{username}/likes/makes":{"parameters":[{"$ref":"#/components/parameters/Username"}],"get":{"tags":["likes"],"summary":"Get the list of makes liked by a user (as pages)","operationId":"get_liked_makes_by","parameters":[{"$ref":"#/components/parameters/Start"},{"$ref":"#/components/parameters/Limit"},{"$ref":"#/components/parameters/Search"},{"$ref":"#/components/parameters/Sort"},{"$ref":"#/components/parameters/Reverse"},{"$ref":"#/components/parameters/Liked"}],"responses":{"200":{"$ref":"#/components/responses/PageOfMakes"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/like":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/MakeId"}],"get":{"tags":["likes"],"summary":"Get if the current user likes a make","operationId":"is_make_liked","security":[{"jwt":[]}],"responses":{"200":{"$ref":"#/components/responses/Boolean"},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"post":{"tags":["likes"],"summary":"Mark that the current user likes a make","operationId":"like_make","security":[{"jwt":[]}],"responses":{"200":{"description":"make was already liked","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"liked make","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}},"delete":{"tags":["likes"],"summary":"Un-Mark that the current user likes a make","operationId":"unlike_make","security":[{"jwt":[]}],"responses":{"200":{"description":"make was already not liked","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"201":{"description":"no longer liked make","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"401":{"$ref":"#/components/responses/Unauthorized"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/liked-by/{username}":{"parameters":[{"$ref":"#/components/parameters/MakeId"},{"$ref":"#/components/parameters/Username"}],"get":{"tags":["likes"],"summary":"Get if the user likes a make","operationId":"is_make_liked_by","responses":{"200":{"$ref":"#/components/responses/Boolean"},"404":{"$ref":"#/components/responses/NotFound"}}}},"/makes/{make}/likes":{"parameters":[{"$ref":"#/components/parameters/DesignId"},{"$ref":"#/components/parameters/MakeId"}],"get":{"tags":["likes"],"summary":"Get the list of users who like a make (as pages)","operationId":"get_make_likes","parameters":[{"$ref":"#/com
[...]
